<!DOCTYPE html>
<html lang="ua">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="style.css">
    <title>Sigma AS 227</title>
</head>
<body>
    <div class="table">
        <div class="display">
            <input type="text" onkeyup="update()" id="input">
        </div>
    </div>

    <div class="formatting" id="animsList">
    </div>

    <div class="buttons">
        <div class="information item">
            <button onclick="send()">Надіслати</button>
            <button onclick="newLine()">Наступний рядок</button>
            <button onclick="clearData()">Очистити усе</button>
        </div>

        <div class="functions item">
            <button onclick="test()">Тестові написи</button>
            <button onclick="insert24Hour()">Вставити 24 годинний час</button> <!-- ^F -->
            <button onclick="insertDate()">Вставити дату YYYY-MM-DD</button> <!-- ^B -->
            <button onclick="syncDate()">Синхронізувати час та дату</button>
        </div>
    </div>

    <div class="info_field">
        <h3>Зовнішній перегляд:</h3>
        <ul class="preview" id="preview">
            <li></li>
        </ul>
    </div>

    <script type="text/javascript">
        const base = ['5c', '62', '5c', '73'];

        var sendArray = [];
        var template = [];
        const url = window.location.href;
        const list = document.getElementById("preview");
        const animSelection = document.getElementById("animsList");

        const alphabet = "АБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯҐЇІабвгдеёжзийклмнопрстуфхцчшщъыьэюяґїі";
        const bytes = ['41', '81', '42', '83', '84', '45', '86', '87', '88', '89', '8A', '4B', '8C', '8D', '48', '4F', '90', '50', '43', '54', '94', '95', '58', '97', '98', '99', '9A', '9B', '9C', '62', '9E', '9F', 'A0', '3F', '3F', '49', '61', 'A2', 'A3', 'A4', 'A5', '65', 'A7', 'A8', 'A9', 'AA', 'AB', '6B', 'AD', 'AE', 'AF', '6F', 'B1', '70', '63', 'E0', 'E1', 'E2', '78', 'E4', 'E5', 'E6', 'E7', 'E8', 'E9', 'EA', 'EB', 'EC', 'ED', '3F', '3F', '69'];

        const anims = {
            "A": "Циклічний",
            "B": "Відразу",
            "C": "Відкриття справа",
            "D": "Відкриття зліва",
            "E": "Відкриття з центру",
            "F": "Відкриття до центру",
            "G": "Закриття з центру",
            "H": "Закриття справа",
            "I": "Закриття зліва",
            "J": "Закриття до центру",
            "K": "Прокрутка до верху",
            "L": "Прокрутка до низу",
            "O": "Закриття знизу",
            "P": "Закриття зверху",
            "R": "Бавовна",
            "S": "Pac Man",
            "T": "Падіння",
            "U": "Постріл",
            "V": "Спалах",
            "W": "Випадкове",
            "X": "Слайдинг"
        };

        for (const i in anims) {
            var div = document.createElement('div')
            div.setAttribute("style", "display: flex")

            var child = document.createElement('input')
            child.setAttribute("style", "margin: 0px; width: min-content")
            child.setAttribute("type", "radio");
            child.id = i;
            child.name = "selectAnim";

            var label = document.createElement('p');
            label.setAttribute("style", "margin: 0px; width: max-content");
            label.textContent = anims[i];

            div.appendChild(child);
            div.appendChild(label);

            animSelection.appendChild(div);
        }


        function test() {
            const xhr = new XMLHttpRequest();
            xhr.open("POST", url+'bytes', true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.send("data=" + '74');
        }

        function clearData() {
            window.location.reload();
        }

        function insert24Hour() {
            template = [];

            var li = document.createElement("li");
            list.appendChild(li);

            template = template.concat(base);
            template.unshift(getAnim().charCodeAt(0).toString(16));
            template = template.concat(hexConvert("^F"));
            template.push("0D");
            sendArray = sendArray.concat(template);

            list.lastElementChild.appendChild(document.createTextNode("DAY 12:00"));
        }

        function insertDate() {
            template = [];

            var li = document.createElement("li");
            list.appendChild(li);

            template = template.concat(base);
            template.unshift(getAnim().charCodeAt(0).toString(16));
            template = template.concat(hexConvert("^B"));
            template.push("0D");
            sendArray = sendArray.concat(template);

            list.lastElementChild.appendChild(document.createTextNode("2023-08-12"));
        }

        function update(event) {
            var input = document.getElementById("input");
            var value = input.value;
            list.lastElementChild.innerText = value;
        }

        function syncDate() {
            const date = new Date();
            var day = date.getDay();
            var year = date.getYear().toString().substring(1);
            var month = (date.getMonth() + 1) < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1;
            var dayCalendar = date.getDate() < 10 ? '0'+date.getDate() : date.getDate();
            var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
            var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
            var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();

            const dataString = hexConvert('E'+day+'0'+year+month+dayCalendar+hours+minutes+seconds);

            const data = (dataString.toString()).replaceAll(",", " ");

            const xhr = new XMLHttpRequest();
            xhr.open("POST", url+'bytes', true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.send("data=" + data);
        }

        function hexConvert(textInput) {
            const array = [];
            for (let i = 0; i < textInput.length; i++) {
                const char = textInput[i];

                if (alphabet.includes(char)) {
                    const index = alphabet.indexOf(char);
                    array.push(bytes[index]);
                }
                else {
                    array.push(char.charCodeAt(0).toString(16));
                }
            }

            return array;
        }

        function send() {
            template = [];
            const text = document.getElementById("input").value;

            var data = hexConvert(text);

            if (text.length > 0) {
                template = template.concat(base);
                template.unshift(getAnim().charCodeAt(0).toString(16));
                template = template.concat(data);
            }

            sendArray = sendArray.concat(template).toString().replaceAll(",", " ");
            console.log(sendArray);
            const xhr = new XMLHttpRequest();
            xhr.open("POST", url+'send', true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.send("data=" + sendArray);
            //window.location.reload();
        }

        function newLine() {
            template = [];

            const text = document.getElementById("input").value;

            if (text.length > 0) {
                var li = document.createElement("li");
                list.appendChild(li);


                document.getElementById("input").value = "";

                var data = hexConvert(text);
                template = template.concat(base);
                template.unshift(getAnim().charCodeAt(0).toString(16));
                template = template.concat(data);
                template.push("0D");
                sendArray = sendArray.concat(template);
            }
        }

        function getAnim() {
            var elems = document.getElementsByName('selectAnim');

            for (i = 0; i < elems.length; i++) {
                if (elems[i].checked) {
                    return elems[i].id
                }
            }

            return "A"
        }
    </script>
</body>
</html>